<?php
/***************************************************************************/
/*                                                                         */
/*  HLAVNI STRANKA - SEZNAM SKUPIN  				                               */
/*                                                                         */
/***************************************************************************/
// 16.12.2024 opraveno nezobrazovani grouplist

  include ("php/head.php");
  include ("php/menu.php");
  flush();  
  require_once ("php/misc.php");

	if(isset($_GET['dir']))
	{	// je nastaveno razeni
		$_SESSION['dir'] = urldecode($_GET['dir']);
  }
  else
  {
    $_SESSION['dir'] = 'up';
  }  

  require_once "php/mysql.php"; 

  include ("php/js_misc.php");

  // zrusime vyber group
  set_group_id(0);

  js_begin("
              function updateTableHeader() {
                var window_pos = GetScrollY();
                var head_line = document.getElementById('head_line');
                var head_div = document.getElementById('table_header');
  
                if( window_pos > GetPos(head_line) )
                {
                  head_div.style.visibility = \"visible\";
                  head_div.style.width = \"0px\";
                  head_div.style.top = document.body.scrollTop;
                }
                else
                {
                  head_div.style.visibility = \"hidden\";  
                }
              }    
  ");


  // pripojeni k DB
  $link = db_connect();
            
  // ukazatel na aktualni stranku seznamu
  if (!isset($_GET['set']))
  { // otevrit prvni stranku seznamu
    $set = 1;
  }
  else
  {	// otevrit zadanou stranku seznamu
    $set = $_GET['set'];
  }        
        
  // pocet polozek na strance seznamu
            
  if( isset($_GET['on_page']) )
  {
    if( ($_GET['on_page'] == 25) | ($_GET['on_page'] == 100) | ($_GET['on_page'] == 1000) )
    {
      $_SESSION['count_on_page'] = $_GET['on_page']; 
    }
  }
  if( !isset($_SESSION['count_on_page']) )
  {
    $_SESSION['count_on_page'] = 25;
  }
        
  // zjisteni poctu vsech zarizeni
  $sql = 'SELECT COUNT(*) FROM groups';
  // vykonani SQL prikazu
  $result = db_query($link, $sql);
            
  list($temp_set) = mysqli_fetch_row($result);
  $count_all_groups = $temp_set;
  $temp_set = ceil($temp_set / 25);
  if($set > $temp_set)
  { // neplatna hodnota $set
    $set = $temp_set;
  }

  if($set<1)
  {	// neplatna hodnota set
    $set = 1;
  }
            
  if(isset($_GET['description_filter']))
  {	// je nastaven filtr name
    $_SESSION['description_filter'] = sanitize_text($_GET['description_filter']);
  }

  if(isset($_GET['company_filter']))
  {	// je nastaven filtr company
    $_SESSION['company_filter'] = sanitize_text($_GET['company_filter']);
  }

  if(isset($_GET['ord']))
  {	// je nastaven filtr firmware
    $_SESSION['ord'] = sanitize_text($_GET['ord']);
  }
  else
  {
    unset($_SESSION['ord']);
//    unset($_SESSION['dir']);
  }

?>
            <tr>
              <th colspan="3">Group List</th>
            </tr>
            <tr>
              <td align="center" colspan="3">
                <table cellspacing="0" cellpadding="1" border="1" style="border-collapse:collapse;" id="dev_list_table">
                  <tr id="head_line">
<?php
  $cell = array();

  $cell[] = "<td nowrap width=\"50px\" height=\"25px\" align=\"center\" class=\"header\"><a href=\"index.php?page=group_list&ord=group_num&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">:.</a></td>\n";
  $cell[] = "<td nowrap align=\"center\" class=\"header\" width=\"170px\"><a href=\"index.php?page=group_list&ord=description&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">Name</a></td>\n";
  if( is_superadmin() )
  {
    $cell[] = "<td nowrap align=\"center\" class=\"header\" width=\"170px\">Company</td>\n";
  }  
  $cell[] = "<td nowrap align=\"center\" class=\"header\" width=\"100px\">Level Limit</td>\n";
  $cell[] = "<td nowrap align=\"center\" class=\"header\" width=\"120px\">Quality Limit</td>\n";
  $cell[] = "<td nowrap align=\"center\" class=\"header\" width=\"120px\">Traffic Limit</td>\n";
  $cell[] = "<td nowrap align=\"center\" class=\"header\" width=\"120px\">2nd Traffic Limit</td>\n";
  $cell[] = "<td nowrap align=\"center\" class=\"header\" width=\"120px\">3rd Traffic Limit</td>\n";
  $cell[] = "<td nowrap align=\"center\" class=\"header\" width=\"120px\">Min Temp Limit</td>\n";
  $cell[] = "<td nowrap align=\"center\" class=\"header\" width=\"120px\">Max Temp Limit</td>\n";
  $cell[] = "<td nowrap align=\"center\" class=\"header\" width=\"125px\">Min Voltage Limit</td>\n";
  $cell[] = "<td nowrap align=\"center\" class=\"header\" width=\"125px\">Max Voltage Limit</td>\n";
  $cell[] = "<td nowrap align=\"center\" class=\"header\" width=\"125px\">Max fails avail</td>\n";
  $cell[] = "<td nowrap align=\"center\" class=\"header\" width=\"125px\">Max fails email/sms</td>\n";
  $cell[] = "<td nowrap align=\"center\" class=\"header\" width=\"125px\">Delay email/sms</td>\n";

  if( is_admin() )
  {
    $cell[] = "<td nowrap align=\"center\" class=\"header\" width=\"70px\" colspan=\"2\">Operation</td>\n";
  }

  foreach($cell as $i => $val)
  {
    echo "                    ".$val;
  }

?>
                  </tr>
                  <tr class="tab_line1" align="center">
                  <form id="filtr" action="index.php" method="get">
                    <input id="filtr" type="hidden" name="page" value="group_list">
<?php
  $filter = array();

  $filter[] = "<td><input id=\"filtr\" class=\"filter_button\" type=\"submit\" value=\"Filter\"></td>\n";
  $filter[] = "<td><input id=\"filtr\" type=\"text\" name=\"description_filter\" value=\"".(isset($_SESSION['description_filter']) ? $_SESSION['description_filter'] : '')."\" size=\"20\"></td>\n";
  if( is_superadmin() )
  {
    $sql = 'SELECT DISTINCT company_id, name
            FROM companies ORDER BY name';

    // vykonani SQL prikazu 
    $result = db_query($link, $sql);

    $temp = "<td><select id=\"filtr\" name=\"company_filter\">";    
    $temp = $temp."<option value=\"\">";

    while(list( $company_id, $company_name ) = mysqli_fetch_row( $result ))
    {
      $temp = $temp."<option value=\"".$company_id."\"".($_SESSION['company_filter'] == $company_id ? ' selected' : '').">".$company_name;     
    }

    $temp = $temp."</select></td>";

    $filter[] = $temp;  
  }
  $filter[] = "<td></td>\n";
  $filter[] = "<td></td>\n";
  $filter[] = "<td></td>\n";
  $filter[] = "<td></td>\n";
  $filter[] = "<td></td>\n";
  $filter[] = "<td></td>\n";
  $filter[] = "<td></td>\n";
  $filter[] = "<td></td>\n";
  $filter[] = "<td></td>\n";
  $filter[] = "<td></td>\n";
  $filter[] = "<td></td>\n";
  $filter[] = "<td></td>\n";
  $filter[] = "<td></td>\n";
  if( is_admin() )
  {
    $filter[] = "<td colspan=\"2\"></td>\n";
  }

  foreach($filter as $i => $val)
  {
    echo "                    ".$val;
  }  

?>
                  </form id="filtr">
                  </tr>
<?php
			
  $sql = '';
					
  if((isset($_SESSION['description_filter'])) && ($_SESSION['description_filter'] != ''))
  {
    $sql = $sql.'AND description LIKE "%'.mysqli_real_escape_string($link,$_SESSION['description_filter']).'%" ';                 
  }

  if((isset($_SESSION['company_filter'])) && ($_SESSION['company_filter'] != ''))
  {
    $sql = $sql.'AND company_id = "'.mysqli_real_escape_string($link,$_SESSION['company_filter']).'" ';                 
  }

  if((isset($_SESSION['ord'])) && ($_SESSION['ord'] != ''))
  {
    $sql = $sql.'ORDER BY '.mysqli_real_escape_string($link,$_SESSION['ord']).' ';          
  }

  if((isset($_SESSION['dir'])) && ($_SESSION['dir'] != ''))
  {
    if($_SESSION['dir'] == 'down')
    {
      $sql = $sql.'DESC ';
    }
  }
						
  $sql = $sql.'LIMIT '. (($set - 1) * $_SESSION['count_on_page']).','.$_SESSION['count_on_page'];    

  if( is_superadmin() )
  {
    $sql = 'call sp_GetGroupsAll(\''.$sql.'\')';  
  }
  else if( is_admin() )
  {
    $sql = 'call sp_GetGroupsCompany(\''.$sql.'\',\''.get_company_id().'\')';
  }
  else
  {
    $sql = 'call sp_GetGroupsUser(\''.$sql.'\',\''.get_user_id().'\')';
  }

  // vykonani SQL prikazu
	$result = db_query($link, $sql);

  $i = 0;
  // nacteni dat z odpovedi
  while (list($group_num,$group_id, $comp_name, $description, $level_limit, $traffic_limit, $traffic_limit_alt, $traffic_limit_alt2, $temp_limit_lo, $temp_limit_hi, $volt_limit_lo, $volt_limit_hi, $qual_limit_lo, $max_fails, $max_fails_msg, $delay_msg) = mysqli_fetch_row($result))
  {
    // kontrola hodnot
    $description        = is_null($description) ? "---" : $description;
    $comp_name          = is_null($comp_name) ? "---" : $comp_name;
    $level_limit        = is_null($level_limit) ? "---" : $level_limit." dBm";
    $traffic_limit      = is_null($traffic_limit) ? "---" : ConvertNumBytes($traffic_limit);
    $traffic_limit_alt  = is_null($traffic_limit_alt) ? "---" : ConvertNumBytes($traffic_limit_alt);    
    $traffic_limit_alt2 = is_null($traffic_limit_alt2) ? "---" : ConvertNumBytes($traffic_limit_alt2);
    $temp_limit_lo      = is_null($temp_limit_lo) ? "---" : $temp_limit_lo." &deg;C";
    $temp_limit_hi      = is_null($temp_limit_hi) ? "---" : $temp_limit_hi." &deg;C";
    $volt_limit_lo      = is_null($volt_limit_lo) ? "---" : $volt_limit_lo." V";
    $volt_limit_hi      = is_null($volt_limit_hi) ? "---" : $volt_limit_hi." V";
    $qual_limit_lo      = is_null($qual_limit_lo) ? "---" : $qual_limit_lo." dB";
    $max_fails          = is_null($max_fails) ? "---" : $max_fails."";
    $max_fails_msg      = is_null($max_fails_msg) ? "---" : $max_fails_msg."";
    $delay_msg          = is_null($delay_msg) ? "---" : $delay_msg."";

    // vytvoreni jednoho radku tabulky
    echo "                  <tr align=\"center\" class=\"tab_line".($i % 2)."\" height=\"27px\">\n";
    echo "                    <td>".$group_num."</td>\n";
    echo "                    <td><a href=\"index.php?page=device_list&group_filter=".$group_id."\">".$description."</a></td>\n";
    if( is_superadmin() )
    {
      echo "                    <td>".$comp_name."</td>\n";    
    }
    echo "                    <td>".$level_limit."</td>\n";
    echo "                    <td>".$qual_limit_lo."</td>\n";
    echo "                    <td>".$traffic_limit."</td>\n";
    echo "                    <td>".$traffic_limit_alt."</td>\n";
    echo "                    <td>".$traffic_limit_alt2."</td>\n";
    echo "                    <td>".$temp_limit_lo."</td>\n";
    echo "                    <td>".$temp_limit_hi."</td>\n";
    echo "                    <td>".$volt_limit_lo."</td>\n";
    echo "                    <td>".$volt_limit_hi."</td>\n";
    echo "                    <td>".$max_fails."</td>\n";
    echo "                    <td>".$max_fails_msg."</td>\n";
    echo "                    <td>".$delay_msg."</td>\n";

    if( is_admin() )
    {
      echo "                    <td><img src=\"img/pencil.png\" border=\"0\" valign=\"center\" onclick=\"window.open('index.php?page=edit_group_form&group_id=".$group_id."','_self');\" title=\"Edit Group\"></td>\n";     
      echo "                    <td><img src=\"img/cross.png\" border=\"0\" valign=\"center\" onclick=\"do_link('index.php?page=group_change&oper=remove&group_id=".$group_id."','Are you sure?');\" title=\"Remove Group\"></td>\n";
    }

    echo "                  </tr>\n";
    $i++;
  }
 
	if(mysqli_more_results($link))
	{	//Catch 'OK'/'ERR'
		while(mysqli_next_result($link));
	}     

  // ziskani poctu vsech zarizeni vyhovujicich filtru
  $sql = 'SELECT COUNT(*) FROM groups WHERE ""="" ';
						
  if((isset($_SESSION['description_filter'])) && ($_SESSION['description_filter'] != ""))
  {	// zahrneme filtr description
    $sql = $sql.'AND description LIKE "%'.mysqli_real_escape_string($link,$_SESSION['description_filter']).'%" ';                 
  }

  if((isset($_SESSION['company_filter'])) && ($_SESSION['company_filter'] != ""))
  {	// zahrneme filtr description
    $sql = $sql.'AND company_id = "'.mysqli_real_escape_string($link,$_SESSION['company_filter']).'" ';                 
  }

  // vykonani SQL prikazu
  $result = db_query($link, $sql);
           
  // nacteni dat z odpovedi
  list($count_filtered) = mysqli_fetch_row($result); 
                
  // uvolneni pameti
  mysqli_free_result($result);
  // uzavreni spojeni s DB
  mysqli_close($link);  
        
?>
                </table>
              </td>
            </tr>
            <tr>
              <td colspan="3">
                <table width="100%">
                  <tr>
                    <td align="left">
                      <table>
                        <tr>
                          <td>
                          </td>
                        </tr>
<?php

  if( $cfg['user_link_target'] != '')
  {
    echo "                        <tr>\n";
    echo "                          <td><a href=\"http://".$cfg['user_link_target']."\">".($cfg['user_link_text'] == '' ? $cfg['user_link_target'] : $cfg['user_link_text'])."</a></td>\n";
    echo "                        </tr>\n";
  }

?>
                      </table>
                    </td>
                    <td align="center">
                      <table>
                        <tr>
                          <td align="center" colspan="4">
                          </td>
                        </tr>
                        <tr height="20px">
                        </tr>
                      </table>
                    </td>
                    <td align="right">
<?php
      
// generovani tlacitek strankovani
						
  // funkce pro vytvoreni odkazu
  function getPageLink($i, $page)
  {
    if($i == $page)
    {	// aktualni stranka nebude odkazem
      return "                        <td class=\"aktivni\">". $i ."</td>\n";
    }
    // odkaz na stranku
    return "                        <td><a href=\"".($i != 1 ? '?set='.$i : '.')."\">".$i."</a></td>\n";
  }
          
  // celkovy pocet stranek
  $maxset = ceil($count_filtered/$_SESSION['count_on_page']);           
                      
  // pocet okolnich stranek				
  $neighbours = 9;
           
  echo "                      <table class=\"navlist\">\n";
  echo "                        <tr>\n";
								
  // odkaz na prvni stranku bude vzdy	
  echo(getPageLink(1, $set));
							
  if($set > $neighbours)
  {	// stranka po prvni strance je dale nez $neighbours
    echo "                        <td>...</td>\n";
  }
							
  // pocet stranek mezi
  $to = min($maxset, $set + $neighbours);
  for($i = max(2, $set - $neighbours + 1); $i < $to; $i++)
  {	// generovani prostrednich stranek
    echo(getPageLink($i, $set));
  }
           
  if($set + $neighbours < $maxset)
  {	// stranka pred posledni strankou je dale nez $neighbours
    echo "                        <td>...</td>\n";
  }
           
  if($maxset > 1)
  {	// odkaz na posledni stranku bude vzdy
    echo(getPageLink($maxset, $set));           
  }
  echo "                        </tr>\n";
  echo "                      </table>\n";
?>
                      <a href=index.php?page=group_list&on_page=25>25</a> | <a href=index.php?page=group_list&on_page=100>100</a> records per page
                      <form style="margin-bottom: 0px" action="index.php" method="get">
                        <label for="gotopage">Go to page</label>                
                        <input type="text" name="set" id="gotopage" size="3">
                      </form>
                    </td>
                  </tr>
                </table>
                <style>
                  #table_header{
                    position: absolute;
                    visibility: hidden;
                  }
                </style>
                <div id="table_header">
                  <table cellspacing="0" cellpadding="1" border="1" style="border-collapse:collapse;" width="100%">
                    <tr>
<?php
  foreach($cell as $i => $val)
  {
    echo "                    ".$val;
  }
?>
                    </tr>
                    <tr class="tab_line1" align="center">
                    <form id="filtr" action="index.php" method="get">
                      <input id="filtr" type="hidden" name="page" value="group_list">
<?php
  foreach($filter as $i => $val)
  {
    echo "                    ".$val;
  }
?>
                  </table>
                </div>
              </td>
            </tr>
<?php

  js_end("
            window.onscroll = function () {
              updateTableHeader();
            }    
    ");

	// pripojeni paticky
  include ("php/bottom.php");

?>
